% CIS601 - Tom Gradel - Homework 4

% Clean up any old figures
close all;

% Number of images
IFIGURE = 5;
im = cell(IFIGURE,1); % Cell array for images

% Images are roughly the same sime, but trim images to this size
IROW = 255;
ICOL = 302;

I = imread('cutty-sark_gray.jpg');
im{1,1} = I([1:IROW],[1:ICOL]);
I = imread('kite_gray_clip.jpg');
im{2,1} = I([1:IROW],[1:ICOL]);
I = imread('kite-bl_gray_clip.jpg');
im{3,1} = I([1:IROW],[1:ICOL]);
I = imread('red-kite_gray_clip.jpg');
im{4,1} = I([1:IROW],[1:ICOL]);
I = imread('ship_gray_clip.jpg');
im{5,1} = I([1:IROW],[1:ICOL]);

% Show the images
for x=1:IFIGURE
    figure, imshow(im{x,1});  title ['figure: ', num2str(x)];
end

% Use vector norm to compare each image.
d = ones(IFIGURE) .* 99999e5;
for x = 1:IFIGURE
    imX = imhist(im{x,1},256);
    for y = 1:IFIGURE
        if (x ~= y)
            imY = imhist(im{y,1},256);
            delta = imX - imY;
            d(x,y) = sum(delta .* delta);
        end
    end
end
% display the matrix of differences
disp(d);
[y,i] = min(d);
disp('Index of closest image using histogram matching');
disp(i);


% Use vector norm to compare each image.
d = ones(IFIGURE) .* 99999999;
for x = 1:IFIGURE
    imX = double(im{x,1}(:));
    for y = 1:IFIGURE
        if (x ~= y)
            d(x,y) = norm([ imX; double(im{y,1}(:))]);
        end
    end
end

% display the matrix of differences
disp(d);
[y,i] = min(d);
disp('Index of closest image using vector norm');
disp(i);




